=== deb/debian/changelog ===
dsnote (4.6.1-1) unstable; urgency=low

  * v4.6.1 release.

 -- LFdev <lfdev+deb@envs.net>  Fri, 23 Ago 2024 19:05:00 -0300
 

dsnote (4.5.0-1) unstable; urgency=low

  * Initial release.

 -- LFdev <lfdev+deb@envs.net>  Sat, 29 Jun 2024 19:05:00 -0300
